package me.wazup.hideandseek;

import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import me.clip.placeholderapi.expansion.PlaceholderExpansion;

public class PlaceholderHooks extends PlaceholderExpansion
{
    private final HideAndSeek plugin;
    
    public PlaceholderHooks(final Plugin plugin) {
        this.plugin = (HideAndSeek)plugin;
    }
    
    public boolean persist() {
        return true;
    }
    
    public boolean canRegister() {
        return true;
    }
    
    public String onPlaceholderRequest(final Player player, final String s) {
        if (s.equals("players_count")) {
            return String.valueOf(this.plugin.game.size());
        }
        if (s.contains("arena_status_")) {
            final Arena value = Arena.valueOf(s.replace("arena_status_", ""));
            if (value != null) {
                return value.state.text;
            }
            return "NoArena";
        }
        else if (s.contains("arena_players_")) {
            final Arena value2 = Arena.valueOf(s.replace("arena_players_", "").toLowerCase());
            if (value2 != null) {
                return String.valueOf(value2.players.size());
            }
            return "NoArena";
        }
        else if (s.contains("arena_max_players_")) {
            final Arena value3 = Arena.valueOf(s.replace("arena_max_players_", "").toLowerCase());
            if (value3 != null) {
                return String.valueOf(value3.maxPlayers);
            }
            return "NoArena";
        }
        else if (s.equals("bungee_arena_status")) {
            if (this.plugin.bungeeMode.selectedArena != null) {
                return this.plugin.bungeeMode.selectedArena.state.text;
            }
            return "NoArena";
        }
        else {
            if (player == null) {
                return "";
            }
            final PlayerData playerData = this.plugin.playerData.get(player.getName());
            if (s.equals("hiders_killed")) {
                return String.valueOf(playerData.hidersKilled);
            }
            if (s.equals("seekers_killed")) {
                return String.valueOf(playerData.seekersKilled);
            }
            if (s.equals("coins")) {
                return String.valueOf(playerData.getCoins(player));
            }
            if (s.equals("wins")) {
                return String.valueOf(playerData.wins);
            }
            if (s.equals("modifier")) {
                return String.valueOf(playerData.modifier);
            }
            if (s.equals("games_played")) {
                return String.valueOf(playerData.gamesPlayed);
            }
            if (s.equals("karma")) {
                return String.valueOf(playerData.karma);
            }
            if (s.equals("hider_chance")) {
                return String.valueOf(playerData.hiderChance);
            }
            if (s.equals("special_blocks")) {
                return String.valueOf(playerData.specialBlocks.size());
            }
            if (s.equals("perks")) {
                return String.valueOf(playerData.perks);
            }
            if (s.equals("exp")) {
                return String.valueOf(playerData.playerExp);
            }
            if (s.equals("rank")) {
                return String.valueOf((playerData.rank != null) ? playerData.rank.name : "");
            }
            if (s.equals("next_rank_exp")) {
                return String.valueOf((playerData.rank != null && playerData.rank.nextRank != null) ? Integer.valueOf(playerData.rank.nextRank.requiredExp) : "");
            }
            if (s.equals("next_rank_name")) {
                return String.valueOf((playerData.rank != null && playerData.rank.nextRank != null) ? playerData.rank.nextRank.name : "");
            }
            if (s.equals("arena_hiders")) {
                return String.valueOf((playerData.arena != null) ? Integer.valueOf(playerData.arena.hiders.size()) : "");
            }
            if (s.equals("arena_seekers")) {
                return String.valueOf((playerData.arena != null) ? Integer.valueOf(playerData.arena.seekers.size()) : "");
            }
            return null;
        }
    }
    
    public String getAuthor() {
        return this.plugin.getDescription().getAuthors().toString();
    }
    
    public String getIdentifier() {
        return "hideandseek";
    }
    
    public String getVersion() {
        return this.plugin.getDescription().getVersion();
    }
}
